Loading...
Searching...
No Matches
Opm::TwoPhaseLETCurves< TraitsT, ParamsT > Class Template Reference

Implementation of the LET curve saturation functions. More...

`#include <TwoPhaseLETCurves.hpp>`

Inheritance diagram for Opm::TwoPhaseLETCurves< TraitsT, ParamsT >:

## Public Types

using | Traits = TraitsT
using | Params = ParamsT
using | Scalar = typename Traits::Scalar

## Static Public Member Functions

template<class Container, class FluidState>
static void | capillaryPressures (Container &, const Params &, const FluidState &)
| The capillary pressure-saturation curves.
template<class Container, class FluidState>
static void | saturations (Container &, const Params &, const FluidState &)
| Calculate the saturations of the phases starting from their pressure differences.
template<class Container, class FluidState>
static void | relativePermeabilities (Container &, const Params &, const FluidState &)
| The relative permeability-saturation curves.
template<class FluidState, class Evaluation = typename FluidState::Scalar>
static Evaluation | pcnw (const Params &, const FluidState &)
| The capillary pressure-saturation curve.
template<class Evaluation>
static Evaluation | twoPhaseSatPcnw (const Params &params, const Evaluation &Sw)
template<class Evaluation>
static Evaluation | twoPhaseSatPcnwInv (const Params &, const Evaluation &)
template<class FluidState, class Evaluation = typename FluidState::Scalar>
static Evaluation | Sw (const Params &, const FluidState &)
template<class Evaluation>
static Evaluation | twoPhaseSatSw (const Params &, const Evaluation &)
template<class FluidState, class Evaluation = typename FluidState::Scalar>
static Evaluation | Sn (const Params &, const FluidState &)
template<class Evaluation>
static Evaluation | twoPhaseSatSn (const Params &, const Evaluation &)
template<class FluidState, class Evaluation = typename FluidState::Scalar>
static Evaluation | krw (const Params &, const FluidState &)
| The relative permeability for the wetting phase of the medium implied by the LET parameterization.
template<class Evaluation>
static Evaluation | twoPhaseSatKrw (const Params &params, const Evaluation &Sw)
template<class Evaluation>
static Evaluation | twoPhaseSatKrLET (const unsigned phaseIdx, const Params &params, const Evaluation &S)
template<class Evaluation>
static Evaluation | twoPhaseSatKrwInv (const Params &, const Evaluation &)
template<class FluidState, class Evaluation = typename FluidState::Scalar>
static Evaluation | krn (const Params &, const FluidState &)
| The relative permeability for the non-wetting phase of the medium as implied by the LET parameterization.
template<class Evaluation>
static Evaluation | twoPhaseSatKrn (const Params &params, const Evaluation &Sw)
template<class Evaluation>
static Evaluation | twoPhaseSatKrnInv (const Params &params, const Evaluation &krn)

## Static Public Attributes

static constexpr Scalar | eps = 1.0e-10
static constexpr int | numPhases = Traits::numPhases
| The number of fluid phases to which this material law applies.
static constexpr bool | implementsTwoPhaseApi = true
| Specify whether this material law implements the two-phase convenience API.
static constexpr bool | implementsTwoPhaseSatApi = true
| Specify whether this material law implements the two-phase convenience API which only depends on the phase saturations.
static constexpr bool | isSaturationDependent = true
| Specify whether the quantities defined by this material law are saturation dependent.
static constexpr bool | isPressureDependent = false
| Specify whether the quantities defined by this material law are dependent on the absolute pressure.
static constexpr bool | isTemperatureDependent = false
| Specify whether the quantities defined by this material law are temperature dependent.
static constexpr bool | isCompositionDependent = false
| Specify whether the quantities defined by this material law are dependent on the phase composition.

## Detailed Description

template<class TraitsT, class ParamsT = TwoPhaseLETCurvesParams<TraitsT>>
class Opm::TwoPhaseLETCurves< TraitsT, ParamsT >

Implementation of the LET curve saturation functions.

This class provides the "raw" curves as static members and relies on the class EffToAbsLaw for converting absolute to effective saturations and vice versa.

See also
  LETCurvesParams

## Member Function Documentation

## krn()

template<class TraitsT, class ParamsT = TwoPhaseLETCurvesParams<TraitsT>>
template<class FluidState, class Evaluation = typename FluidState::Scalar>

Evaluation Opm::TwoPhaseLETCurves< TraitsT, ParamsT >::krn | ( | const Params & | ,
|  | const FluidState & | )

inline static

The relative permeability for the non-wetting phase of the medium as implied by the LET parameterization.

Parameters

  params | The parameters of the capillary pressure curve

## krw()

template<class TraitsT, class ParamsT = TwoPhaseLETCurvesParams<TraitsT>>
template<class FluidState, class Evaluation = typename FluidState::Scalar>

Evaluation Opm::TwoPhaseLETCurves< TraitsT, ParamsT >::krw | ( | const Params & | ,
|  | const FluidState & | )

inline static

The relative permeability for the wetting phase of the medium implied by the LET parameterization.

Parameters

  params | The parameters of the relative permeability curve

## pcnw()

template<class TraitsT, class ParamsT = TwoPhaseLETCurvesParams<TraitsT>>
template<class FluidState, class Evaluation = typename FluidState::Scalar>

Evaluation Opm::TwoPhaseLETCurves< TraitsT, ParamsT >::pcnw | ( | const Params & | ,
|  | const FluidState & | )

inline static

The capillary pressure-saturation curve.

Parameters

  params | The parameters of the capillary pressure curve

## relativePermeabilities()

template<class TraitsT, class ParamsT = TwoPhaseLETCurvesParams<TraitsT>>
template<class Container, class FluidState>

void Opm::TwoPhaseLETCurves< TraitsT, ParamsT >::relativePermeabilities | ( | Container & | ,
|  | const Params & | ,
|  | const FluidState & | )

inline static

The relative permeability-saturation curves.

Parameters

  values | A random access container which stores the relative permeability of each fluid phase.
  params | The parameter object expressing the coefficients required by the material law.
  fs | The fluid state for which the relative permeabilities ought to be calculated

The documentation for this class was generated from the following file:

- opm/material/fluidmatrixinteractions/TwoPhaseLETCurves.hpp